/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataCloudflareApiTokenPermissionGroupsConfig extends cdktf.TerraformMetaArguments {
}
/**
* Represents a {@link https://registry.terraform.io/providers/cloudflare/cloudflare/4.36.0/docs/data-sources/api_token_permission_groups cloudflare_api_token_permission_groups}
*/
export declare class DataCloudflareApiTokenPermissionGroups extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "cloudflare_api_token_permission_groups";
    /**
    * Generates CDKTF code for importing a DataCloudflareApiTokenPermissionGroups resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataCloudflareApiTokenPermissionGroups to import
    * @param importFromId The id of the existing DataCloudflareApiTokenPermissionGroups that should be imported. Refer to the {@link https://registry.terraform.io/providers/cloudflare/cloudflare/4.36.0/docs/data-sources/api_token_permission_groups#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataCloudflareApiTokenPermissionGroups to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/cloudflare/cloudflare/4.36.0/docs/data-sources/api_token_permission_groups cloudflare_api_token_permission_groups} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataCloudflareApiTokenPermissionGroupsConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataCloudflareApiTokenPermissionGroupsConfig);
    private _account;
    get account(): cdktf.StringMap;
    get id(): string;
    private _permissions;
    get permissions(): cdktf.StringMap;
    private _r2;
    get r2(): cdktf.StringMap;
    private _user;
    get user(): cdktf.StringMap;
    private _zone;
    get zone(): cdktf.StringMap;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
