/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataCloudflareDlpDatasetsConfig extends cdktf.TerraformMetaArguments {
    /**
    * The account ID to fetch DLP Datasets from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/4.36.0/docs/data-sources/dlp_datasets#account_id DataCloudflareDlpDatasets#account_id}
    */
    readonly accountId: string;
}
export interface DataCloudflareDlpDatasetsDatasets {
}
export declare function dataCloudflareDlpDatasetsDatasetsToTerraform(struct?: DataCloudflareDlpDatasetsDatasets): any;
export declare function dataCloudflareDlpDatasetsDatasetsToHclTerraform(struct?: DataCloudflareDlpDatasetsDatasets): any;
export declare class DataCloudflareDlpDatasetsDatasetsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataCloudflareDlpDatasetsDatasets | undefined;
    set internalValue(value: DataCloudflareDlpDatasetsDatasets | undefined);
    get description(): string;
    get id(): string;
    get name(): string;
    get secret(): cdktf.IResolvable;
    get status(): string;
}
export declare class DataCloudflareDlpDatasetsDatasetsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataCloudflareDlpDatasetsDatasetsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/cloudflare/cloudflare/4.36.0/docs/data-sources/dlp_datasets cloudflare_dlp_datasets}
*/
export declare class DataCloudflareDlpDatasets extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "cloudflare_dlp_datasets";
    /**
    * Generates CDKTF code for importing a DataCloudflareDlpDatasets resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataCloudflareDlpDatasets to import
    * @param importFromId The id of the existing DataCloudflareDlpDatasets that should be imported. Refer to the {@link https://registry.terraform.io/providers/cloudflare/cloudflare/4.36.0/docs/data-sources/dlp_datasets#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataCloudflareDlpDatasets to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/cloudflare/cloudflare/4.36.0/docs/data-sources/dlp_datasets cloudflare_dlp_datasets} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataCloudflareDlpDatasetsConfig
    */
    constructor(scope: Construct, id: string, config: DataCloudflareDlpDatasetsConfig);
    private _accountId?;
    get accountId(): string;
    set accountId(value: string);
    get accountIdInput(): string | undefined;
    private _datasets;
    get datasets(): DataCloudflareDlpDatasetsDatasetsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
